Change default Dolphin toolbar layout
ClosedPublic

Authored by simonkr on Aug 10 2019, 7:16 PM.

Details

Summary

Use a default toolbar layout that looks better and makes more sense for new users.

Test Plan

Open Dolphin (with the default toolbar)

Diff Detail

Repository
R318 Dolphin
Lint
Lint Skipped
Unit
Unit Tests Skipped
There are a very large number of changes, so older changes are hidden. Show Older Changes
Restricted Application added a subscriber: kfm-devel. · View Herald TranscriptAug 10 2019, 7:16 PM
simonkr requested review of this revision.Aug 10 2019, 7:16 PM
ngraham requested changes to this revision.Aug 10 2019, 7:22 PM
ngraham added a subscriber: ngraham.

+1, I love it. I would even add New Folder or Create New to the toolbar as well, but that's just me.

However this needs some technical changes to proceed:

  • Please adjust CMakeLists.txt to increase the frameworks dependency version to 5.51 (prior to that version, the expanding spacer didn't exist)
  • Please bump the version number at the top of dolphinui.rc (this needs to be done in every patch/commit that changes anything in an .rc file)
This revision now requires changes to proceed.Aug 10 2019, 7:22 PM
ngraham added inline comments.Aug 10 2019, 7:26 PM
src/dolphinmainwindow.cpp
1730

Tooltips are written as commands or sentences. Maybe change this to something like "Show menu"

ndavis added a subscriber: ndavis.Aug 10 2019, 7:44 PM

Make sure the default layout doesn't look lopsided when the application menu is enabled instead of the control button.

simonkr updated this revision to Diff 63504.Aug 10 2019, 7:52 PM
ngraham added inline comments.Aug 10 2019, 7:53 PM
CMakeLists.txt
11

Needs to be 5.61.0 (i.e. follow the existing pattern)

simonkr updated this revision to Diff 63506.Aug 10 2019, 7:59 PM

Update the CMakeLists.txt File, i changed 5.61 to 5.61.0

Don't forget about the other inline comment too. :) You can also mark the comments as done and then hit Submit to mark them as done.

simonkr updated this revision to Diff 63508.Aug 10 2019, 8:02 PM
simonkr marked an inline comment as done.

In the file dolphinmainwindow.cpp i changed m_controlButton->setToolTip(i18nc("@action", "Menu")); to m_controlButton->setToolTip(i18nc("@action", "Show menu"));

simonkr marked an inline comment as done.Aug 10 2019, 8:06 PM
simonkr added inline comments.
CMakeLists.txt
11

Done! :)

src/dolphinmainwindow.cpp
1730

Done! :)

simonkr marked 3 inline comments as done.Aug 10 2019, 8:07 PM
simonkr marked 4 inline comments as not done.Aug 10 2019, 8:12 PM
simonkr marked 2 inline comments as done.
simonkr marked 2 inline comments as done.Aug 10 2019, 8:14 PM

This looks great to me now. Testing it out, the new layout feels much nicer:

However I have one hesitation regarding replacing the three individual view mode buttons with a drop-down menu button. It feels like an unnecessary change. I'm not against it, but I also don't see a particularly strong reason for it either. Can you explain your reasoning for this?

This looks great to me now. Testing it out, the new layout feels much nicer:

However I have one hesitation regarding replacing the three individual view mode buttons with a drop-down menu button. It feels like an unnecessary change. I'm not against it, but I also don't see a particularly strong reason for it either. Can you explain your reasoning for this?

I just changed it, because others in the VDG chat thought it's odd that the view buttons have no labels. I'll change it back.

You don't necessarily have to, I just wanted to start a conversation about it. :) I do like the symmetry of the actions on the periphery being icons-only and the ones in the middle having icons.

GB_2 added a subscriber: GB_2.Aug 10 2019, 8:38 PM

You don't necessarily have to, I just wanted to start a conversation about it. :) I do like the symmetry of the actions on the periphery being icons-only and the ones in the middle having icons.

I think having 3 icon only buttons is still more efficient, you need one less click to change the view mode. This is also how other file managers have it.

simonkr updated this revision to Diff 63513.Aug 10 2019, 8:51 PM

Use three individual view mode buttons

simonkr edited the summary of this revision. (Show Details)Aug 10 2019, 8:53 PM

There wasn't much discussion about using the view mode button in the VDG:

<thavn> perhaps we should consider which buttons have labels and which are just the icon as well...
<noahdvs> I find it odd that we use icons with no labels for the different views
<noahdvs> Maybe we should switch them for the View Mode toolbutton?

I think the biggest reason for it is that the label makes it clear that these buttons change the view mode. Clicking it also shows the names of the three different view modes so users can decide by the names and not just by the icons. It also teaches the user the shortcuts for them.
I think it looks better with the view mode button.

Make sure the default layout doesn't look lopsided when the application menu is enabled instead of the control button.

It does look kinda lopsided but I am not sure if it is worth it to change the default look because of that.

GB_2 accepted this revision.Aug 10 2019, 9:00 PM

There wasn't much discussion about using the view mode button in the VDG:

<thavn> perhaps we should consider which buttons have labels and which are just the icon as well...
<noahdvs> I find it odd that we use icons with no labels for the different views
<noahdvs> Maybe we should switch them for the View Mode toolbutton?

I think the biggest reason for it is that the label makes it clear that these buttons change the view mode. Clicking it also shows the names of the three different view modes so users can decide by the names and not just by the icons. It also teaches the user the shortcuts for them.
I think it looks better with the view mode button.

Make sure the default layout doesn't look lopsided when the application menu is enabled instead of the control button.

It does look kinda lopsided but I am not sure if it is worth it to change the default look because of that.

It's fine how it is now, how it also was before. There are tooltips for the buttons, and if we really want to show a shortcut, we can do it in the tooltip, but then everywhere in a different patch.

ngraham accepted this revision.Aug 10 2019, 9:14 PM
ngraham added a subscriber: elvisangelaccio.

LGTM. Let's make sure Dolphin's maintainer @elvisangelaccio is good with it too!

This revision is now accepted and ready to land.Aug 10 2019, 9:14 PM

We should probably keep the show preview button unless we want to enable previews by default.

They are enabled by default.

ndavis added a comment.EditedAug 12 2019, 1:53 AM

They are enabled by default.

Ok. If we're not going to have a button to enable/disable them by default, we should disable previews for documents under a certain size. Maybe =< 32px or =< 22px?

This is not very nice to look at

... compared to this

ndavis added a comment.EditedAug 12 2019, 2:05 AM

Make sure the default layout doesn't look lopsided when the application menu is enabled instead of the control button.

It does look kinda lopsided but I am not sure if it is worth it to change the default look because of that.

I think it is because you can enable the full application menu without any confirmation or editing dialog. If we just move the split button over to the right side, it should improve the symmetry a bit. It could be further justified by saying that the buttons on the left are only for normal file viewing functions (this is where Nate's mom and dad should look) and the functions on the right are for more advanced features. I also think that it could be easy to overlook the search button with no label and only 1 or 2 small icons on the right side. If you move split over to the right side, that makes it easier to spot the magnifying glass next to it.

GB_2 added a comment.Aug 12 2019, 6:57 AM
This comment was removed by GB_2.
GB_2 added a comment.Aug 12 2019, 7:02 AM


Is this better?

ndavis added a comment.EditedAug 12 2019, 7:57 AM
In D23075#510674, @GB_2 wrote:


Is this better?

I think the view mode buttons should be replaced by the single View Mode menu button. Unlabelled icons are a bad idea unless the symbol is very common and very distinct. I don't think it's reasonable to expect people to understand the compact mode and icon mode icons without looking at the tooltip.

I think the Sort By button should also be on the left.

If a Create New button is also added after more discussion, I think it should also be on the left.

meven added a subscriber: meven.Aug 12 2019, 8:03 AM
In D23075#510674, @GB_2 wrote:


Is this better?

I think the view mode buttons should be replace by the single View Mode menu button. Unlabelled icons are a bad idea unless the symbol is very common and very distinct.

D12077 added the view mode buttons to open/save dialog for consistency with current dolphin.
So my point would be that given they have distinct icons and are used with the same exact semantic elsewhere, it could be a good idea to keep them.
If we decide we'd rather use the single view mode menu button, the same change should be applied to KFileWidget/KDirOperator.

GB_2 added a comment.Aug 12 2019, 8:03 AM
In D23075#510674, @GB_2 wrote:


Is this better?

I think the view mode buttons should be replaced by the single View Mode menu button. Unlabelled icons are a bad idea unless the symbol is very common and very distinct. I don't think it's reasonable to expect people to understand the compact mode and icon mode icons without looking at the tooltip.

I think the Sort By button should also be on the left.

If a Create New button is also added after more discussion, I think it should also be on the left.

Did you read my comments about the view mode button?

In D23075#510680, @GB_2 wrote:
In D23075#510674, @GB_2 wrote:


Is this better?

I think the view mode buttons should be replaced by the single View Mode menu button. Unlabelled icons are a bad idea unless the symbol is very common and very distinct. I don't think it's reasonable to expect people to understand the compact mode and icon mode icons without looking at the tooltip.

I think the Sort By button should also be on the left.

If a Create New button is also added after more discussion, I think it should also be on the left.

Did you read my comments about the view mode button?

No, I missed them, but now I've seen them.

In D23075#510016, @GB_2 wrote:

I think having 3 icon only buttons is still more efficient, you need one less click to change the view mode. This is also how other file managers have it.

Yes, once you have the muscle memory, 3 buttons is more efficient. Maybe it's just a pet peeve of mine that I'm getting hung up on, but I hate having to read a tooltip when I'm not 100% sure what an icon means before I click the button. BTW, Windows 10 doesn't show icon-only view mode buttons, although File Explorer is by no means a good standard for UI design. MacOS has 4 icon-only view mode buttons (ew) and GNOME has 1 that seems to flip between the thumbnail and list modes

GB_2 added a comment.Aug 12 2019, 9:30 AM


This is my final proposal with a category structure.

[Previews] are enabled by default.

Ok. If we're not going to have a button to enable/disable them by default, we should disable previews for documents under a certain size. Maybe =< 32px or =< 22px?

This is not very nice to look at

... compared to this

I think this example is a very specific occurence for technical users. Most will imo be happy to just have the preview turned on without the need to change that because:

  • Previews for text files are turned off by default
  • File types have a lot of meaning for us whereas most don't care if they open an .odt or .doc file
  • Browsing files where a preview is useless and the file type helps a lot in differentiating is (probably) a rare occurence (.h/.cpp). If there are a bunch of .odt and .doc files in a folder then the preview is more relevant than what type there is.

So I think we should remove the preview button by default.

filipf added a subscriber: filipf.Aug 12 2019, 11:25 AM
In D23075#510697, @GB_2 wrote:


This is my final proposal with a category structure.

I could be persuaded to have the Split button on the left, but either way this looks good.

GB_2 added a comment.EditedAug 12 2019, 11:35 AM
In D23075#510697, @GB_2 wrote:


This is my final proposal with a category structure.

I could be persuaded to have the Split button on the left, but either way this looks good.

I put it on the right (miscellaneous) because the split button doesn't change properties of the current view, a new view is also on the right side and to make the search or menu buttons not look lopsided.

simonkr updated this revision to Diff 63604.Aug 12 2019, 12:59 PM

Update dolphinui.rc

GB_2 accepted this revision.Aug 12 2019, 1:00 PM
GB_2 edited the summary of this revision. (Show Details)
GB_2 edited the summary of this revision. (Show Details)Aug 12 2019, 1:07 PM

I think this example is a very specific occurence for technical users. Most will imo be happy to just have the preview turned on without the need to change that because:

  • Previews for text files are turned off by default
  • File types have a lot of meaning for us whereas most don't care if they open an .odt or .doc file
  • Browsing files where a preview is useless and the file type helps a lot in differentiating is (probably) a rare occurence (.h/.cpp). If there are a bunch of .odt and .doc files in a folder then the preview is more relevant than what type there is. So I think we should remove the preview button by default.

Agreed. As a supplementary thing, perhaps we could have text file previews stop displaying for small sizes, as they become unreadable and are truly useless. But other preview types that show predominatatel visual content are always useful, even at small sizes:

Either way, material for another patch. :)

In D23075#510697, @GB_2 wrote:


This is my final proposal with a category structure.

I think this is fine. It seems like I'm in the minority here with my opinion on the view mode buttons, so I'll just let that go.

I think this is fine. It seems like I'm in the minority here with my opinion on the view mode buttons, so I'll just let that go.

I would be okay using a drop-down menu if:

  1. The title and icon of the button reflected the active mode as they do for Okular's toolbuttons with menus
  2. Drop-down menu toolbuttons got downward-pointing arrows with the Breeze widget theme (https://bugs.kde.org/show_bug.cgi?id=344746)

Material for another time, IMO.

GB_2 added a comment.Aug 12 2019, 7:45 PM

So now we wait for @elvisangelaccio :-)

Wow, this is quite a radical change :)

I'm not against changing the default layout, but we should be 100% sure to get it right. It would be very annoying if we have to change it again in six months because people didn't like it.

My comments after a quick try:

  1. I don't think we should add the "Go Up" button because you can already achieve the same action by using the url navigator buttons.
  2. Why the Split button on the right? It looks out of place imho.
  3. I wouldn't remove the Stash button because it shows up only if you have kio-stash installed. And it's a nice feature to advertise imho (it was the output of a GSoC project some years ago).
  4. This is possibly a problem in my setup, but this patch made my information panel disappear :O

Wow, this is quite a radical change :)

I'm not against changing the default layout, but we should be 100% sure to get it right. It would be very annoying if we have to change it again in six months because people didn't like it.

My comments after a quick try:

  1. I don't think we should add the "Go Up" button because you can already achieve the same action by using the url navigator buttons.

I kind of agree, but don't have a strong opinion since it's a common control in file managers and doesn't take up much space.

  1. Why the Split button on the right? It looks out of place imho.
  1. Because the controls on the left are "normal" controls that can be used whether you're using the regular file view or not. The controls on the right introduce other views like search and split view. Stash could go on the right side as well with that logic.
  2. Because we needed something on the right to give the GUI a bit more visual balance when the application menu is enabled.
  1. I wouldn't remove the Stash button because it shows up only if you have kio-stash installed. And it's a nice feature to advertise imho (it was the output of a GSoC project some years ago).

Fair point. Might be off-topic, but I'm not sure what the usecase for stash is. I installed it as soon as it was available, but I don't know when I'd ever use it.

  1. This is possibly a problem in my setup, but this patch made my information panel disappear :O

Looking at the diff, I see nothing in this patch that would do that. However, I am experiencing the same problem with the version of git master Dolphin that I compiled with kdesrc-build. I'm not sure what causes the problem, but the version of git master dolphin provided by openSUSE's KDE:Unstable repos still has the info panel.

When your information panel disappears with git master, usually that means your baloo-widgets is out of date. It really should be integrated into Dolphin's own repo IMO since Dolphin is the only user.

simonkr updated this revision to Diff 63782.Aug 15 2019, 8:37 AM

Edit dolphinui.rc Add <Action name="split_stash" /> Before <Action name="split_view" />

ngraham accepted this revision.Sun, Aug 18, 1:36 AM

Wow, this is quite a radical change :)

I'm not against changing the default layout, but we should be 100% sure to get it right. It would be very annoying if we have to change it again in six months because people didn't like it.

My comments after a quick try:

  1. I don't think we should add the "Go Up" button because you can already achieve the same action by using the url navigator buttons.

I kind of agree, but don't have a strong opinion since it's a common control in file managers and doesn't take up much space.

Well, if I'm not wrong only the Windows explorer has it. Nautilus and the MacOS explorer don't.

  1. Why the Split button on the right? It looks out of place imho.
  1. Because the controls on the left are "normal" controls that can be used whether you're using the regular file view or not. The controls on the right introduce other views like search and split view. Stash could go on the right side as well with that logic.
  2. Because we needed something on the right to give the GUI a bit more visual balance when the application menu is enabled.

I see, makes sense.

TL;DR Looks good besides the Up button :)

@simonkr All right, let's remove the Up button and get this landed!

@simonkr All right, let's remove the Up button and get this landed!

Is the Up button in the dolphinui.rc ?. Cuz i cant find the code line right now 😅

ngraham added inline comments.Sun, Aug 25, 3:26 PM
src/dolphinui.rc
96

Yes, you added it here. :)

simonkr updated this revision to Diff 64590.Sun, Aug 25, 3:30 PM

Delete <Action name="go_up" /> in src/dolphinui.rc

simonkr marked an inline comment as done.Sun, Aug 25, 3:31 PM
ngraham accepted this revision.Sun, Aug 25, 3:31 PM

Delete <Action name="go_up" /> in src/dolphinui.rc

@ngraham Done!. Sry, my Brain is a bit tired today :D

This revision was automatically updated to reflect the committed changes.
GB_2 added a comment.Sun, Aug 25, 4:01 PM

Why remove the up button when it doesn't use much space and is useful?
Just because these file managers don't have it doesn't mean we also shouldn't include it (Nemo, Thunar, PCManFM have it for example). It is very useful when you navigate back and forth between different directories, but then want to quickly go back to the folder that is a few folders above. If you would use the back button then you would have to click it a lot more.
You can also use it when you are in a pinned directoy and easily want to go to the parent folder.

GB_2 added a comment.Sun, Aug 25, 4:01 PM
This comment was removed by GB_2.
In D23075#518967, @GB_2 wrote:

Why remove the up button when it doesn't use much space and is useful?
Just because these file managers don't have it doesn't mean we also shouldn't include it (Nemo, Thunar, PCManFM have it for example). It is very useful when you navigate back and forth between different directories, but then want to quickly go back to the folder that is a few folders above. If you would use the back button then you would have to click it a lot more.
You can also use it when you are in a pinned directoy and easily want to go to the parent folder.

Because you can "go up" using the url navigator. It is true that it doesn't take much space, but that doesn't mean that we should waste it. We should reserve this space in case we decide to add another action in one, two or ten years. ;)

I find myself using the URL Navigator to go up far more in GNOME software than in Dolphin. I think that's because the GNOME version actually looks far more clickable than ours does. Maybe if we improve that, then people will be more subtly, psychologically comfortable using it to go up?